package com.madeu.controller.web.webappevent;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webappevent.WebAppEventService;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;

@Slf4j
@Controller
public class WebAppEventController extends ManagerDraftAction {

    @Autowired
    private WebAppEventService webAppEventService;

    @Autowired
    private WebLogHistoryService webLogHistoryService;

    /**
     * 앱 이벤트 정보 리스트 조회 (option)
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappevent/selectListAppEventOption.do")
    public ModelAndView selectListAppEventOption(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebAppEventController selectListAppEventOption START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppEventService.selectListAppEventOption(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebAppEventController selectListAppEventOption END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 이벤트 리스트 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappevent/selectListEventIntro.do")
    public String  selectListAppEventIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebAppEventController  selectListAppEventIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppEventService.selectListAppEventIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebAppEventController  selectListAppEventIntro END");
        return "/web/appevent/appEventSelectList";
    }

    /**
     * 앱 이벤트 정보 리스트 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappevent/selectListAppEvent.do")
    public ModelAndView selectListAppEvent(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebAppEventController selectListAppEvent START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppEventService.selectListAppEvent(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebAppEventController selectListAppEvent END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 엡 이벤트 정보 상세 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappevent/selectAppEvent.do")
    public ModelAndView selectAppEvent(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebAppEventController selectAppEvent START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppEventService.selectAppEvent(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebAppEventController selectAppEvent END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 이벤트 상세 등록 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappevent/insertEventIntro.do")
    public String  insertEventIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebAppEventController  insertEventIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppEventService.insertAppEventIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebAppContentsController  insertEventIntro END");
        return "/web/appevent/appEventInsert";
    }

    /**
     * 앱 이벤트 정보 등록
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappevent/insertAppEvent.do")
    public ModelAndView insertAppEvent(HttpSession session,HttpServletRequest request, HttpServletResponse response,@RequestParam(value = "file", required = false) MultipartFile file) {
        log.debug("WebAppEventController insertAppEvent START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppEventService.insertAppEvent(paramMap,file);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webappevent/insertAppEvent.do");
                insertMap.put("func", "insertAppEvent");
                insertMap.put("funcName", "앱 이벤트 등록");
                insertMap.put("service", "webAppEventService");
                insertMap.put("serviceName", "앱 이벤트 등록");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebAppEventController insertAppEvent END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 이벤트 상세 수정 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappevent/updateEventIntro.do")
    public String  updateEventIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebAppEventController  updateEventIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppEventService.updateAppEventIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebAppContentsController  updateEventIntro END");
        return "/web/appevent/appEventUpdate";
    }

    /**
     * 앱 이벤트 정보 수정
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappevent/updateAppEvent.do")
    public ModelAndView updateAppEvent(HttpSession session,HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file) {
        log.debug("WebAppEventController updateAppEvent START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppEventService.updateAppEvent(paramMap,file);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webappevent/updateAppEvent.do");
                insertMap.put("func", "updateAppEvent");
                insertMap.put("funcName", "앱 이벤트 수정");
                insertMap.put("service", "webAppEventService");
                insertMap.put("serviceName", "앱 이벤트 수정");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebAppEventController updateAppEvent END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }


    /**
     * 앱 이벤트 정보 삭제
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappevent/deleteAppEvent.do")
    public ModelAndView deleteAppEvent(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebAppEventController deleteAppEvent START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppEventService.deleteAppEvent(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webappevent/deleteAppEvent.do");
                insertMap.put("func", "deleteAppEvent");
                insertMap.put("funcName", "앱 이벤트 삭제");
                insertMap.put("service", "webAppEventService");
                insertMap.put("serviceName", "앱 이벤트 삭제");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebAppEventController deleteAppEvent END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
}


